/*
    Program realizujici razeni retezcu (nezavisle na tom,
    zda-li jsou zapsany velkymi nebo malymi pismeny).
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h> /* Obsahuje prototyp funkce toupper */

#define N 7
#define MAX 10

void velkymiPismeny(char *s1, char *s2)
{
    int i=0;

    strcpy(s2,s1);
    while (s2[i]!='\0')
    {
      s2[i]=toupper(s2[i]);
      i++;
    }
}

void vypisJmena(char a[][MAX], unsigned short pocet)
{
    for (unsigned short i=0; i<pocet-1; i++)
        printf("%s ",a[i]);
    printf("%s\n\n",a[pocet-1]);
}

void seradJmena(char a[][MAX], unsigned short pocet)
{
    unsigned short i,j,h;
    char pom[MAX],v1[MAX],v2[MAX];

    for (i=0; i<pocet-1; i++)
    {
        j=i;
        for (h=i+1; h<pocet; h++)
        {
          velkymiPismeny(a[h],v1);
          velkymiPismeny(a[j],v2);
          if (strcmp(v1,v2)<0) j=h;
        }

        strcpy(pom,a[i]);
        strcpy(a[i],a[j]);
        strcpy(a[j],pom);
    }
}

int main(void)
{
    char jmena[N][MAX]={"PAVEL", "Petr", "michal",
       "Honza", "Marek", "ivan", "LUDEK"};

    puts("Neserazena jmena:");
    vypisJmena(jmena,N);
    seradJmena(jmena,N);
    puts("Serazena jmena:");
    vypisJmena(jmena,N);

    return 0;
}
