/*
    Program demonstrujici praci s retezci 3.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int strChrPos(const char *str, int c)
{
    char *p;

    p=strchr(str,c);
    if (p) return p-str;
           else return -1;
}

int strRChrPos(const char *str, int c)
{
    char *p;

    p=strrchr(str,c);
    if (p) return p-str;
           else return -1;
}

int strStrPos(const char *str, const char *substr)
{
    char *p;

    p=strstr(str,substr);
    if (p) return p-str;
           else return -1;
}

char *strIns(char *dest, const char *source, size_t index)
{
    char *pom;

    pom=(char *)malloc(strlen(dest)-index+1);

    strcpy(pom,dest+index);
    dest[index]='\0';
    strcat(dest,source);
    strcat(dest,pom);
    free(pom);

    return dest;
}

char *strDel(char *str, size_t index, size_t pocet)
{
    char *pom;

    pom=(char *)malloc(strlen(str)-(index+pocet-1));

    strcpy(pom,str+index+pocet);
    str[index]='\0';
    strcat(str,pom);
    free(pom);

    return str;
}

int main(void)
{
    char *str, znak;
    char *substr="ram";
    char *cil="Programovani v C";
    char *zdroj="jazyce ";
    char *vlozeni, *vymazani;
    size_t pozice, pocet;

    str=(char *)malloc(13);
    strcpy(str,"Programovani");

    znak='r';
    pozice=strChrPos(str,znak);
    printf("Prvni vyskyt znaku '%c' v retezci \"%s\" je na pozici %d\n\n",
           znak,str,pozice);

    pozice=strRChrPos(str,znak);
    printf("Posledni vyskyt znaku '%c' v retezci \"%s\" je na pozici %d\n\n",
           znak,str,pozice);

    pozice=strStrPos(str,substr);
    printf("Prvni vyskyt podretezce \"%s\" v retezci \"%s\" je od pozice %d\n\n",
           substr,str,pozice);

    free(str);

    pozice=15;
    vlozeni=(char *)malloc(24);
    strcpy(vlozeni,cil);
    strIns(vlozeni,zdroj,pozice);
    printf("Vlozenim retezce \"%s\" od pozice %u do "
           "retezce \"%s\" dostaneme\nretezec \"%s\"\n\n",
           zdroj,pozice,cil,vlozeni);

    pocet=7;
    vymazani=(char*)malloc(24);
    strcpy(vymazani,vlozeni);
    strDel(vymazani,pozice,pocet);
    printf("Vymazanim %u znaku od pozice %u z retezce "
           "\"%s\" dostaneme\nretezec \"%s\"\n",
           pocet,pozice,vlozeni,vymazani);

    free(vlozeni);
    free(vymazani);

    return 0;
}
